@import "../../../core/variables";
@import "../../../core/mixins";

.button {
  position: relative;
  display: inline-flex;

  &:not(.isDisabled) {
    cursor: pointer;
  }

  @include colorize(Color, color);
}

.isDisabled {
  cursor: not-allowed;
}

.content {
  display: inline-flex;
  align-items: center;
  width: 100%;
}

.text {
  margin: 0 auto;
  line-height: 100%;
  flex-grow: 1;
}

.pureState {
  &.isDisabled {
    opacity: .4;
  }
}

// states
.primaryState {
  background: $color-green;

  &:not(.isDisabled) {
    &:hover,
    &:focus {
      background: $color-green-darker;
    }
  }
}

.secondaryState {
  background: $color-gray-900;

  &:not(.isDisabled) {
    &:hover,
    &:focus {
      background: $color-black;
    }
  }
}

.primaryState,
.secondaryState,
.gradientState,
.outlineState {
  border-radius: 1000px;
  padding: 0 $indent-xmd;

  font-size: $font-size-sm;
  line-height: 100%;

  transition: background .3s ease, box-shadow .15s ease, color .3s ease, transform .15s ease;
  will-change: backgroumd, box-shadow, color, transform;

  &.isDisabled {
    background: $color-gray-600 !important;
    color: $color-white !important;
    box-shadow: none !important;
  }

  &:not(.isDisabled) {
    &:active {
      transform: translateY(1px);
    }
  }
}

.primaryState,
.secondaryState {
  color: $color-white;
  box-shadow: inset 0 -2px 0 transparentize(black, .9);

  &:not(.isDisabled) {
    &:active {
      box-shadow: none !important;
    }
  }
}

.gradientState {
  color: $color-white;
  background: $color-gradient-green;

  &:not(.isDisabled) {
    &:hover,
    &:focus {
      box-shadow: inset 0 -2px 0 transparentize(black, .9);
    }
    &:active {
      box-shadow: inset 0 1px 0 transparentize(black, .9);
    }
  }
}

.outlineState {
  color: $color-green;
  background: $color-white;
  box-shadow: inset 0 0 0 1px $color-green;

  &:not(.isDisabled) {
    &:hover,
    &:focus {
      background: $color-green;
      color: $color-white;
    }
    &:active {
      box-shadow: inset 0 1px 0 transparentize(black, .9);
    }
  }
}

.valueState {
  border-radius: $border-radius-md !important;
}

.tagState {
  //background: $color-white;
  box-shadow: inset 0 0 0 1px $color-gray-600;
  padding: $indent-xs $indent-xmd;
  font-size: $font-size-xs;

  .renderLeft {
    color: $color-gray-800;
    > * {
      height: 22px;
    }
  }

  .renderRight {
    color: $color-gray-600;
  }

  &:not(.isDisabled) {
    &:hover,
    &:focus {
      box-shadow: inset 0 0 0 1px $color-gray-700;

      .renderRight {
        color: $color-gray-700;
      }
    }
  }
}

.navigateState {
  padding: 0 $indent-xsm;
  color: $color-gray-900;
  background: $color-white;
  border-radius: $border-radius-sm;

  &:not(.activeState) {
    box-shadow: inset 0 0 0 1px $color-gray-500;
  }

  &:not(.isDisabled) {
    &:not(.activeState) {
      &:hover {
        color: $color-blue;
      }
    }
  }

  &.isDisabled {
    opacity: .5;
  }

  &.activeState {
    background: $color-blue;
    color: $color-white;
  }
}

.tabState {
  padding: $indent-xmd $indent-xlg;
  border-radius: $border-radius-md $border-radius-md 0 0;

  &.isDisabled {
    opacity: .5;
  }

  &:not(.activeState) {
    color: $color-blue;

    &:not(.isDisabled) {
      &:hover {
        background: $color-blue-lighter;
      }
    }
  }

  &.activeState {
    box-shadow: inset 0 0 0 1px $color-gray-600;
    color: $color-gray-900;
    background: $color-white;
  }
}

@each $opacity in (
                (0),
                (10),
                (20),
                (30),
                (40),
                (50),
                (60),
                (70),
                (80),
                (90),
                (100),
) {
  .inactiveOpacity#{$opacity}State {
    transition: opacity .3s ease;
    &:not(.isDisabled) {
      &:not(:hover):not(:focus) {
        opacity: #{$opacity / 100}
      }
    }
  }
}

// props
.stackedFromTop {
  border-top-left-radius: 0 !important;
  border-top-right-radius: 0 !important;
}
.stackedFromRight {
  border-top-right-radius: 0 !important;
  border-bottom-right-radius: 0 !important;
}
.stackedFromBottom {
  border-bottom-left-radius: 0 !important;
  border-bottom-right-radius: 0 !important;
}
.stackedFromLeft {
  border-bottom-left-radius: 0 !important;
  border-top-left-radius: 0 !important;
}

.isBlock {
  width: 100%;
  display: flex;
}

.isCircle {
  border-radius: 100000000px;
}

.isSquare {
  .content {
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    justify-content: center;
  }
}

.renderLeft,
.renderLeftContent {
  + * {
    margin-left: $indent-xsm;
  }
}

.renderRight,
.renderRightContent {
  * + & {
    margin-left: $indent-xsm;
  }
}

// sizes
@each $type, $size, $width in (
  (lt, 32, 40),
  (xs, 36, 42),
  (sm, 42, 84),
  (md, 48, 94),
  (lg, 52, 104),
  (xl, 58, 114),
) {
  .#{$type}Size {
    min-height: #{$size}px;

    &:not(.isSquare) {
      min-width: #{$width}px;
    }

    &.isSquare {
      min-width: #{$size}px;
    }
  }
}

.startAlign {
  align-items: flex-start;
}

.centerAlign {
  align-items: center;
}

.endAlign {
  align-items: flex-start;
}

.startTextAlign {
  .text {
    text-align: left;
  }
}

.centerTextAlign {
  .text {
    text-align: center;
  }
}

.endTextAlign {
  .text {
    text-align: right;
  }
}